using System;
using System.Runtime.InteropServices;

namespace Demo_2_Marshalling
{
	public class Machine
	{
        [StructLayout(LayoutKind.Explicit)]
        public struct SYSTEM_INFO
        {
            [FieldOffset(0)] public UInt32 OemId;
            [FieldOffset(0)] public UInt16 ProcessorArchitecture;
            [FieldOffset(4)] public UInt32 PageSize;
            [FieldOffset(16)] public UInt32 ActiveProcessorMask;
            [FieldOffset(20)] public UInt32 NumberOfProcessors;
            [FieldOffset(24)] public UInt32 ProcessorType;
            [FieldOffset(28)] public UInt32 AllocationGranularity;
        }

        [DllImport("kernel32.dll", EntryPoint="GetNativeSystemInfo")]
        private static extern void _GetNativeSystemInfo(ref SYSTEM_INFO sysInfo);

        public static SYSTEM_INFO GetSystemInfo()
        {
            SYSTEM_INFO sysInfo = new SYSTEM_INFO();
            _GetNativeSystemInfo(ref sysInfo);

            return sysInfo;
        }
	}
}
